package com.qmth.themis.business.enums;

import java.util.Objects;

/**
 * @Description: 上传文件类型
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/7/15
 */
public enum UploadFileEnum {

    client(0),

    base_photo(1),

    upload(2),

    file(3);

    private int id;

    private UploadFileEnum(int id) {
        this.id = id;
    }

    public int getId() {
        return id;
    }

    /**
     * 状态转换 toId
     *
     * @param value
     * @return
     */
    public static int convertToId(String value) {
        if (Objects.equals(value.trim(), client.name())) {
            return client.getId();
        } else if (Objects.equals(value.trim(), base_photo.name())) {
            return base_photo.getId();
        } else if (Objects.equals(value.trim(), upload.name())) {
            return upload.getId();
        } else {
            return file.getId();
        }
    }

    /**
     * 状态转换 toName
     *
     * @param value
     * @return
     */
    public static String convertToName(int value) {
        if (value == client.getId()) {
            return client.name();
        } else if (value == base_photo.getId()) {
            return base_photo.name();
        } else if (value == upload.getId()) {
            return upload.name();
        } else {
            return file.name();
        }
    }
}
